from rlife import Pattern
from collections import defaultdict

def Outcome(pattern, maxGens, strict=False):
    t = skip = 0
    while True:
        n = min(maxGens - t, skip)
        pattern = pattern[n]
        t += n
        skip = maxGens >> 4
        if t >= maxGens:
            rc = 5
        else:
            pattern, n, rc = pattern.monitor(maxGens - t)
            t += n
        partition = defaultdict(Pattern)
        if rc == 5: break
        if rc <= 2:
            partition[0, 0] = pattern
            break
        for q in pattern.census(6):
            if not q.divine(12): continue
            partition[q.stride] += q
        if not strict: break
        n = 4 * min(pattern.box[2], pattern.box[3])
        if pattern[n] == sum(q[n] for q in partition.itervalues()):
            break
    return pattern, t, rc, partition
